<template>
    <div>
        <h1>Онлайн каталог</h1>
        <div class="filter">
            <strong>Название запчасти</strong>
            <v-select class="category" placeholder="Запчасть" label="1"
                      :options="$store.state.api.options.part_type"
                      :loading="$store.state.api.loadings.part_type"
                      :value="$store.state.api.values.part_type"
                      @input="select_part_type"
                      @search:focus="get_reference('part_type')">
                <span slot="no-options">Ничего не найдено</span>
            </v-select>
            <v-select class="manufacturer" placeholder="Марка авто" label="1"
                      :options="$store.state.api.options.mark"
                      :loading="$store.state.api.loadings.mark"
                      :value="$store.state.api.values.mark"
                      @input="select_mark"
                      @search:focus="get_reference('mark')">
                <span slot="no-options">Ничего не найдено</span>
            </v-select>
            <v-select class="model" placeholder="Модель авто" label="1"
                      :options="$store.state.api.options.model"
                      :loading="$store.state.api.loadings.model"
                      :value="$store.state.api.values.model"
                      @input="select_model"
                      @search:focus="get_reference('model')">
                <span slot="no-options">{{mark_empty}}</span>
            </v-select>
            <div class="filter__row">
                <strong class="filter__price--label">Цена</strong>
                <input :value="$store.state.api.values.price_from" @change="set_price" name="price_from" type="text" class="filter__input" placeholder="От" />
                <div class="filter__input--separator"></div>
                <input :value="$store.state.api.values.price_to" @change="set_price" name="price_to" type="text" class="filter__input" placeholder="До" />
                <v-select class="engine" placeholder="Двигатель" label="1"
                          :options="$store.state.api.options.engine"
                          :loading="$store.state.api.loadings.engine"
                          :value="$store.state.api.values.engine"
                          @input="select_engine"
                          @search:focus="get_reference('engine')">
                    <span slot="no-options">{{model_empty}}</span>
                </v-select>
                <v-select class="body" placeholder="Кузов" label="1"
                          :options="$store.state.api.options.frame"
                          :loading="$store.state.api.loadings.frame"
                          :value="$store.state.api.values.frame"
                          @input="select_frame"
                          @search:focus="get_reference('frame')">
                    <span slot="no-options">{{model_empty}}</span>
                </v-select>
            </div>
        </div>
        <div class="catalog">
            <div itemscope itemtype="http://schema.org/Product">
                <div v-for="part in parts" :key="part.id" class="catalog__row" @click="go2part(part.sup_invnn)">
                    <div class="catalog__img"><img :src="get_img_path(part)" /></div>
                    <div class="catalog__name"><strong itemprop="name">{{part.part_type_name}}</strong><br><span v-if="part.position">{{part.position}}</span></div>
                    <div class="catalog__info">
                        <p><strong>{{part.sma_name}} {{part.smo_name}}</strong></p>
                        <p class="eb">{{part.sf_name}} <span v-if="part.sf_name">кузов</span> {{part.se_name}} <span v-if="part.se_name">двигатель</span></p>
                    </div>
                    <div class="catalog__price" itemscope itemtype="http://schema.org/Offer"><p class="price" itemprop="price">{{part.price}}</p><p class="instock"><span>{{part.part_status}}</span></p></div>
                    <a v-if="in_cart(part)" class="catalog__button" @click.stop="show_cart" title="Открыть корзину" rel="nofollow">Добавлено</a>
                    <a v-else class="catalog__button" @click.stop="add2cart(part)" rel="nofollow">В корзину</a>
                </div>
                <div v-if="parts.length && !$store.state.api.the_end">
                    <hr>
                    <a v-if="$store.state.api.loading" class="lazy loading">Загрузка</a>
                    <a v-else class="lazy" @click="get_parts(add=true)">Больше запчастей</a>
                </div>
                <div v-if="!parts.length">
                    <h2 style="margin: 40px 0 0;">По вашему запросу ничего не найдено.<br> Вы можете заказать запчасть индивидуально.<br>  Быстро и с доставкой.</h2>
                    <a class="order__button" style="margin: 40px auto; display: block;" @click="show_part">Заказать запчасть</a>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
  import vSelect from 'vue-select'
  import { mapState, mapMutations, mapActions, mapGetters } from 'vuex';

  export default {
    name: 'Catalog',
    computed: {
      ...mapState('api', ['parts']),
      ...mapGetters('cart', ['in_cart']),
      model_empty () {
        return this.$store.state.api.values.model ? 'Ничего не найдено' : 'Сначала выберите модель';
      },
      mark_empty () {
        return this.$store.state.api.values.mark ? 'Ничего не найдено' : 'Сначала выберите марку';
      },
    },
    components: {
      'v-select': vSelect
    },
    methods: {
      ...mapActions('api', [
        'get_parts',
        'get_reference',
        'select_part_type',
        'select_mark',
        'select_model',
        'select_frame',
        'select_engine',
        'set_price']),
      ...mapMutations('cart', ['add2cart', 'show_cart', 'show_part']),
      go2part: function (id) {
        this.$router.push({name: 'part', params: {id: id}});
      },
      get_img_path: function (part) {
        if (part.photos) {
          const path = part.photos.path;
          const item = part.photos.part[0];
          return `https://img.bibinet.ru${path}-${item}_c104x60.jpg`;
        } else {
          return '/img/small.jpg';
        }
      }
    },
    mounted() {
      if (!this.parts.length) {
        this.get_parts();
      }
    }
  }
</script>

<style src="@/assets/css/filter.scss" lang="scss"></style>
<style lang="scss">
    .v-select.loading .spinner {
        margin-top: 4px !important;
    }
</style>
